#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "arduino.h"
#include "request.h"
#include "uss.h"
#include "data.h"
#include "direction.h"
#include "sound.h"
#include "delay.h"
#include "correct.h"
#include "run.h"

#define DATA 16
#define DATA_MAX 100
#define ROT_SPEED 30
#define STR_SPEED 30

int main() {
	int route_count;
	int start[DATA_MAX];
	int goal[DATA_MAX];
	int i = 0;

	int Dist[DATA][DATA]={
    //   	A1		B1		C1		D1		E1		ε		A2		B2		C2		D2		E2		A3		B3		C3		D3		E3
/*A1*/		{-1,		80,		0,		0,		 0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0},
/*B1*/		{80,	 	-1,		150,		0,		 0,		-2,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0},
/*C1*/		{0,		150,		-1,		125,		125,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0},
/*D1*/		{0,		0,		125,		-1,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0},
/*E1*/		{0,		0,		125,		0,		-1,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0},
/*ε*/		{0,		1,		0,		0,		0,		-1,		0,		2,		0,		0,		0,		0,		3,		0,		0,		0},
/*A2*/		{0,		0,		0,		0,		0,		0,		-1,		80,		0,		0,		0,		0,		0,		0,		0,		0},
/*B2*/		{0,		0,		0,		0,		0,		-3,		80,		-1,		150,		0,		0,		0,		0,		0,		0,		0},
/*C2*/		{0,		0,		0,		0,		0,		0,		0,		150,		-1,		125,		125,		0,		0,		0,		0,		0},
/*D2*/		{0,		0,		0,		0,		0,		0,		0,		0,		125,            -1,		0,		0,		0,		0,		0,		0},
/*E2*/		{0,		0,		0,		0,		0,		0,		0,		0,		125,        	0,		-1,		0,		0,		0,		0,		0},
/*A3*/		{0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		-1,		80,             0,		0,		0},
/*B3*/		{0,		0,		0,		0,		0,		-4,		0,		0,		0,		0,		0,		80,             -1,		150,            0,		0},
/*C3*/		{0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		150,            -1,		125,	125},
/*D3*/		{0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		125,        	-1,		0},
/*E3*/		{0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		125,	-1}
	};
	int Dire[DATA][DATA]={
    //		A1		B1		C1		D1		E1		ε		A2		B2		C2		D2		E2		A3		B3		C3		D3		E3
/*A1*/		{-1,    	0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0},
/*B1*/		{0,		-1,		0,		0,		0,		-400,           0,		0,		0,		0,		0,		0,		0,		0,		0,		0},
/*C1*/		{0,		-100,   	-1,		-200,           -300,   	0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0},
/*D1*/		{0,		0,		0,		-1,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0},
/*E1*/		{0,		0,		0,		0,		-1,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0},
/*ε*/ 		{0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0},
/*A2*/		{0,		0,		0,		0,		0,		0,		-1,		0,		0,		0,		0,		0,		0,		0,		0,		0},
/*B2*/		{0,		0,		0,		0,		0,		-400,   	0,		-1,		0,		0,		0,		0,		0,		0,		0,		0},
/*C2*/		{0,		0,		0,		0,		0,		0,		0,		-100,   	-1,		-200,   	-300,           0,		0,		0,		0,		0},
/*D2*/		{0,		0,		0,		0,		0,		0,		0,		0,		0,		-1,		0,		0,		0,		0,		0,		0},
/*E2*/		{0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		-1,		0,		0,		0,		0,		0},
/*A3*/		{0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		-1,		0,		0,		0,		0},
/*B3*/		{0,		0,		0,		0,		0,		-400,           0,		-1,		0,		0,		0,		0,		0,		0,		0,		0},
/*C3*/		{0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		-100,           -1,		-200,	-300},
/*D3*/		{0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		-1,		0},
/*E3*/		{0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		-1}
		};
	int Wall[DATA][DATA]={
    //		A1		B1		C1		D1		E1		ε		A2		B2		C2		D2		E2		A3		B3		C3		D3		E3
/*A1*/		{-1,		4,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0},
/*B1*/		{4,		-1,		1,		0,		0,		-100,           0,		0,		0,		0,		0,		0,		0,		0,		0,		0},
/*C1*/		{0,		4,		-1,		4,		4,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0},
/*D1*/		{0,		0,		3,		-1,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0},
/*E1*/		{0,		0,		2,		0,		-1,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0},
/*ε*/		{0,		1,		0,		0,		0,		-1,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0},
/*A2*/		{0,		0,		0,		0,		0,		0,		-1,		4,		0,		0,		0,		0,		0,		0,		0,		0},
/*B2*/		{0,		0,		0,		0,		0,		-100,           4,		-1,		1,		0,		0,		0,		0,		0,		0,		0},
/*C2*/		{0,		0,		0,		0,		0,		0,		0,		4,		-1,		4,		4,		0,		0,		0,		0,		0},
/*D2*/		{0,		0,		0,		0,		0,		0,		0,		0,		3,		-1,		0,		0,		0,		0,		0,		0},
/*E2*/		{0,		0,		0,		0,		0,		0,		0,		0,		2,		0,		-1,		0,		0,		0,		0,		0},
/*A3*/		{0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		-1,		4,		0,		0,		0},
/*B3*/		{0,		0,		0,		0,		0,		-100,           0,		0,		0,		0,		0,		4,		-1,		1,		0,		0},
/*C3*/		{0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		4,		-1,		4,		4},
/*D3*/		{0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		3,		-1,		0},
/*E3*/		{0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		0,		2,		0,		-1}
	};
	while(1){

	get_route_data(&route_count,start,goal);
	while(i<route_count){
		printf("start[i]=%d:goal[i]=%d\n",start[i],goal[i]);
		i ++;
	}
	i=0;

	if (arduino_open() != 0) return -1;
	if (uss_open_l() != 0) return -1;
	if (uss_open_r() != 0) return -1;
	if(uss_open_f() != 0) return -1;
	if(uss_open_b() != 0) return -1;

	sound(1);
	while (i < route_count){
		if(goal[i]==5){
			sound(3);
		}else if(start[i]==5){
			sound(4);
		}else{
		switch(Dire[start[i]][goal[i]]){
			case -100:
				if(start[i-1] == 3 || start[i-1] == 9 || start[i-1] == 14){
					request_set_runmode(ROT,ROT_SPEED,-90);
					run_delay();
				}else{
					request_set_runmode(ROT,ROT_SPEED,90);
					run_delay();
				}
				break;
			case -200:
				if(start[i-1] == 1 || start[i-1] == 7 || start[i-1] == 12){
					request_set_runmode(ROT,ROT_SPEED,90);
					run_delay();
				}
				break;
			case -300:
				if(start[i-1] == 1 || start[i-1] == 7 || start[i-1] == 12){
					request_set_runmode(ROT,ROT_SPEED,-90);
					run_delay();
				}
	    			break;
			case -400:
				if(start[i-1] == 0 || start[i-1] == 6 || start[i-1] == 11){
					request_set_runmode(ROT, 50, 90);
					run_delay();
				}else{
					request_set_runmode(ROT, 50, -90);
					run_delay();
				}
				break;
			default:
				request_set_runmode(ROT,ROT_SPEED,Dire[start[i]][goal[i]]);
				run_delay();
		}
		request_set_runmode(STR,STR_SPEED,Dist[start[i]][goal[i]]);
//		run(Dist[start[i]][goal[i]]);
	        run_delay();
		point_correct(Dire[start[i+1]][goal[i+1]],Wall[start[i]][goal[i]]);
		}
		i++;
	}
	sound(2);
	request_set_runmode(ROT,20,180);
	run_delay();
	request_set_runmode(STP,0,0);
	arduino_close();
	system("sudo rm route.csv");
	}
	return 0;
}
